Index: cpukit/score/src/corespinlockrelease.c
===================================================================
--- cpukit/score/src/corespinlockrelease.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/corespinlockrelease.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,5 +22,5 @@
 #include <rtems/score/percpu.h>
 
-CORE_spinlock_Status _CORE_spinlock_Surrender(
+Status_Control _CORE_spinlock_Surrender(
   CORE_spinlock_Control *the_spinlock,
   ISR_lock_Context      *lock_context
@@ -37,5 +37,5 @@
     ) {
       _CORE_spinlock_Release( the_spinlock, lock_context );
-      return CORE_SPINLOCK_NOT_HOLDER;
+      return STATUS_NOT_OWNER;
     }
 
@@ -48,4 +48,4 @@
 
   _CORE_spinlock_Release( the_spinlock, lock_context );
-  return CORE_SPINLOCK_SUCCESSFUL;
+  return STATUS_SUCCESSFUL;
 }
Index: cpukit/score/src/corespinlockwait.c
===================================================================
--- cpukit/score/src/corespinlockwait.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/corespinlockwait.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -22,5 +22,5 @@
 #include <rtems/score/percpu.h>
 
-CORE_spinlock_Status _CORE_spinlock_Seize(
+Status_Control _CORE_spinlock_Seize(
   CORE_spinlock_Control *the_spinlock,
   bool                   wait,
@@ -41,5 +41,5 @@
          the_spinlock->holder == executing ) {
       _CORE_spinlock_Release( the_spinlock, lock_context );
-      return CORE_SPINLOCK_HOLDER_RELOCKING;
+      return STATUS_NESTING_NOT_ALLOWED;
     }
     the_spinlock->users += 1;
@@ -49,5 +49,5 @@
         the_spinlock->holder = executing;
         _CORE_spinlock_Release( the_spinlock, lock_context );
-        return CORE_SPINLOCK_SUCCESSFUL;
+        return STATUS_SUCCESSFUL;
       }
 
@@ -58,5 +58,5 @@
         the_spinlock->users -= 1;
         _CORE_spinlock_Release( the_spinlock, lock_context );
-        return CORE_SPINLOCK_UNAVAILABLE;
+        return STATUS_UNAVAILABLE;
       }
 
@@ -68,5 +68,5 @@
           the_spinlock->users -= 1;
           _CORE_spinlock_Release( the_spinlock, lock_context );
-          return CORE_SPINLOCK_TIMEOUT;
+          return STATUS_TIMEOUT;
         }
       #endif
Index: cpukit/score/src/futex.c
===================================================================
--- cpukit/score/src/futex.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/futex.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -91,6 +91,5 @@
       executing,
       STATES_WAITING_FOR_SYS_LOCK_FUTEX,
-      0,
-      0,
+      WATCHDOG_NO_TIMEOUT,
       &lock_context
     );
Index: cpukit/score/src/mpci.c
===================================================================
--- cpukit/score/src/mpci.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/mpci.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -226,9 +226,8 @@
 }
 
-uint32_t   _MPCI_Send_request_packet (
-  uint32_t            destination,
-  MP_packet_Prefix   *the_packet,
-  States_Control      extra_state,
-  uint32_t            timeout_code
+Status_Control _MPCI_Send_request_packet(
+  uint32_t          destination,
+  MP_packet_Prefix *the_packet,
+  States_Control    extra_state
 )
 {
@@ -261,11 +260,10 @@
       executing,
       STATES_WAITING_FOR_RPC_REPLY | extra_state,
-      the_packet->timeout,
-      timeout_code
+      the_packet->timeout
     );
 
   _Thread_Dispatch_enable( cpu_self );
 
-  return executing->Wait.return_code;
+  return _Thread_Wait_get_status( executing );
 }
 
Index: cpukit/score/src/mutex.c
===================================================================
--- cpukit/score/src/mutex.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/mutex.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -120,5 +120,4 @@
     STATES_WAITING_FOR_SYS_LOCK_MUTEX,
     timeout,
-    ETIMEDOUT,
     lock_context
   );
@@ -263,8 +262,7 @@
     }
 
-    executing->Wait.return_code = 0;
     _Mutex_Acquire_slow( mutex, owner, executing, ticks, &lock_context );
 
-    return (int) executing->Wait.return_code;
+    return STATUS_GET_POSIX( _Thread_Wait_get_status( executing ) );
   }
 }
@@ -383,5 +381,4 @@
     }
 
-    executing->Wait.return_code = 0;
     _Mutex_Acquire_slow(
       &mutex->Mutex,
@@ -392,5 +389,5 @@
     );
 
-    return (int) executing->Wait.return_code;
+    return STATUS_GET_POSIX( _Thread_Wait_get_status( executing ) );
   }
 }
Index: cpukit/score/src/semaphore.c
===================================================================
--- cpukit/score/src/semaphore.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/semaphore.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -102,6 +102,5 @@
       executing,
       STATES_WAITING_FOR_SYS_LOCK_SEMAPHORE,
-      0,
-      0,
+      WATCHDOG_NO_TIMEOUT,
       &lock_context
     );
Index: cpukit/score/src/threadmp.c
===================================================================
--- cpukit/score/src/threadmp.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/threadmp.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -147,5 +147,4 @@
     the_proxy->Wait.option                  = executing->Wait.option;
     the_proxy->Wait.return_code             = executing->Wait.return_code;
-    the_proxy->Wait.timeout_code            = executing->Wait.timeout_code;
 
     the_proxy->thread_queue_callout = _Thread_queue_MP_callout_do_nothing;
Index: cpukit/score/src/threadqenqueue.c
===================================================================
--- cpukit/score/src/threadqenqueue.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/threadqenqueue.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -23,4 +23,5 @@
 #include <rtems/score/threaddispatch.h>
 #include <rtems/score/threadimpl.h>
+#include <rtems/score/status.h>
 #include <rtems/score/watchdogimpl.h>
 
@@ -40,5 +41,4 @@
   States_Control                 state,
   Watchdog_Interval              timeout,
-  uint32_t                       timeout_code,
   ISR_lock_Context              *lock_context
 )
@@ -55,4 +55,5 @@
   _Thread_Lock_set( the_thread, &queue->Lock );
 
+  the_thread->Wait.return_code = STATUS_SUCCESSFUL;
   _Thread_Wait_set_queue( the_thread, queue );
   _Thread_Wait_set_operations( the_thread, operations );
@@ -73,5 +74,4 @@
    */
   if ( timeout != WATCHDOG_NO_TIMEOUT ) {
-    _Thread_Wait_set_timeout_code( the_thread, timeout_code );
     _Thread_Timer_insert_relative(
       the_thread,
Index: cpukit/score/src/threadqflush.c
===================================================================
--- cpukit/score/src/threadqflush.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/threadqflush.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -20,4 +20,5 @@
 
 #include <rtems/score/threadimpl.h>
+#include <rtems/score/status.h>
 
 Thread_Control *_Thread_queue_Flush_default_filter(
@@ -27,4 +28,30 @@
 )
 {
+  (void) queue;
+  (void) queue_context;
+  return the_thread;
+}
+
+Thread_Control *_Thread_queue_Flush_status_object_was_deleted(
+  Thread_Control       *the_thread,
+  Thread_queue_Queue   *queue,
+  Thread_queue_Context *queue_context
+)
+{
+  the_thread->Wait.return_code = STATUS_OBJECT_WAS_DELETED;
+
+  (void) queue;
+  (void) queue_context;
+  return the_thread;
+}
+
+Thread_Control *_Thread_queue_Flush_status_unavailable(
+  Thread_Control       *the_thread,
+  Thread_queue_Queue   *queue,
+  Thread_queue_Context *queue_context
+)
+{
+  the_thread->Wait.return_code = STATUS_UNAVAILABLE;
+
   (void) queue;
   (void) queue_context;
Index: cpukit/score/src/threadrestart.c
===================================================================
--- cpukit/score/src/threadrestart.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/threadrestart.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -444,8 +444,8 @@
 
 void _Thread_Join(
-  Thread_Control    *the_thread,
-  States_Control     waiting_for_join,
-  Thread_Control    *executing,
-  ISR_lock_Context  *lock_context
+  Thread_Control   *the_thread,
+  States_Control    waiting_for_join,
+  Thread_Control   *executing,
+  ISR_lock_Context *lock_context
 )
 {
@@ -454,5 +454,4 @@
 
 #if defined(RTEMS_POSIX_API)
-  executing->Wait.return_code = 0;
   executing->Wait.return_argument = NULL;
 #endif
@@ -464,5 +463,4 @@
     waiting_for_join,
     WATCHDOG_NO_TIMEOUT,
-    0,
     lock_context
   );
Index: cpukit/score/src/threadtimeout.c
===================================================================
--- cpukit/score/src/threadtimeout.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ cpukit/score/src/threadtimeout.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -21,8 +21,9 @@
 
 #include <rtems/score/threadimpl.h>
+#include <rtems/score/status.h>
 
 static void _Thread_Do_timeout( Thread_Control *the_thread )
 {
-  the_thread->Wait.return_code = the_thread->Wait.timeout_code;
+  the_thread->Wait.return_code = STATUS_TIMEOUT;
   ( *the_thread->Wait.operations->extract )(
     the_thread->Wait.queue,
Index: testsuites/sptests/spintrcritical10/init.c
===================================================================
--- testsuites/sptests/spintrcritical10/init.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ testsuites/sptests/spintrcritical10/init.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -61,5 +61,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == DEADBEEF
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     sc = rtems_event_send(thread->Object.id, GREEN);
@@ -69,5 +69,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == GREEN
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     sc = rtems_event_send(thread->Object.id, RED);
@@ -77,5 +77,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == GREEN
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     _Thread_Timeout(&thread->Timer.Watchdog);
@@ -84,5 +84,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == GREEN
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     if (ctx->hit) {
@@ -158,5 +158,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == DEADBEEF
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     sc = rtems_event_send(thread->Object.id, GREEN);
@@ -166,5 +166,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == DEADBEEF
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     sc = rtems_event_send(thread->Object.id, RED);
@@ -174,5 +174,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == EVENTS
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     _Thread_Timeout(&thread->Timer.Watchdog);
@@ -181,5 +181,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == EVENTS
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     if (ctx->hit) {
@@ -250,5 +250,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == DEADBEEF
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_SUCCESSFUL);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_SUCCESSFUL);
 
     _Thread_Timeout(&thread->Timer.Watchdog);
@@ -257,5 +257,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == DEADBEEF
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_TIMEOUT);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_TIMEOUT);
 
     sc = rtems_event_send(thread->Object.id, EVENTS);
@@ -265,5 +265,5 @@
       *(rtems_event_set *) thread->Wait.return_argument == DEADBEEF
     );
-    rtems_test_assert(thread->Wait.return_code == RTEMS_TIMEOUT);
+    rtems_test_assert(_Thread_Wait_get_status(thread) == STATUS_TIMEOUT);
 
     if (ctx->hit) {
Index: testsuites/sptests/spintrcritical20/init.c
===================================================================
--- testsuites/sptests/spintrcritical20/init.c	(revision d887c1b5b30733fd2d6cf07a4a264f57ab9f4b4b)
+++ testsuites/sptests/spintrcritical20/init.c	(revision dce487912d98835b8168e755b60514f5a8592b27)
@@ -19,4 +19,5 @@
 #include <tmacros.h>
 #include <intrcritical.h>
+#include <rtems/score/threadimpl.h>
 #include <rtems/score/threadqimpl.h>
 #include <rtems/rtems/semimpl.h>
@@ -45,8 +46,4 @@
 
   ctx->semaphore_task_tcb = _Thread_Get_executing();
-  _Thread_Wait_set_timeout_code(
-    ctx->semaphore_task_tcb,
-    CORE_SEMAPHORE_TIMEOUT
-  );
 
   while (true) {
@@ -77,6 +74,5 @@
 
   rtems_test_assert(
-    ctx->semaphore_task_tcb->Wait.return_code
-      == CORE_SEMAPHORE_STATUS_SUCCESSFUL
+    _Thread_Wait_get_status( ctx->semaphore_task_tcb ) == STATUS_SUCCESSFUL
   );
 
@@ -95,9 +91,9 @@
   _Thread_Timeout(&ctx->semaphore_task_tcb->Timer.Watchdog);
 
-  switch (ctx->semaphore_task_tcb->Wait.return_code) {
-    case CORE_SEMAPHORE_STATUS_SUCCESSFUL:
+  switch (_Thread_Wait_get_status(ctx->semaphore_task_tcb)) {
+    case STATUS_SUCCESSFUL:
       ctx->status_was_successful = true;
       break;
-    case CORE_SEMAPHORE_TIMEOUT:
+    case STATUS_TIMEOUT:
       ctx->status_was_timeout = true;
       break;
